"use strict";
var whoStole = whoStole || {wink:{}};

whoStole.wink.images =
{
    tmbSize: 320.0,
    searchURL:
    {
        yandex:  "https://yandex.ru/images/search?rpt=imageview&img_url=",
        tineye:  "http://www.tineye.com/search/?pluginver=firefox-1.0&url=",
        google:  "https://www.google.com/searchbyimage?encoded_image=&image_content=&filename=&hl=&bih=&biw=&image_url=",
        vk:      "https://vk.com/feed?section=photos_search&q=copy%3A"
    },
    uploadURL:
    {
        yandex:  "https://yandex.ru/images/search?rpt=imageview",
        tineye:  "http://www.tineye.com/search",
        google:  "https://www.google.com/searchbyimage/upload"
    },
    isLocalSearch: false,
    targetURL:  '',
    vkID:  '',

    init: function()
    {
        var menu = document.getElementById("contentAreaContextMenu");
        if (menu)
        {
            menu.addEventListener("popupshowing", whoStole.wink.images.onContext, false);
        }
        whoStole.wink.images.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.images@wink.su.");
        whoStole.wink.images.prefs.QueryInterface(Components.interfaces.nsIPrefBranch);

        if (window.navigator.userAgent.indexOf('SeaMonkey') > 0)
        {
            whoStole.wink.images.prefs.setBoolPref('private', false);
            whoStole.wink.images.prefs.setBoolPref('active', true);
        }
    },

    whereWeOpen: function()
    {
        return (whoStole.wink.images.prefs.getBoolPref('active'))? "tab" : "tabshifted";
    },

    onContext: function(event)
    {
        if (event.target.id !== "contentAreaContextMenu") return;

        var me = whoStole.wink.images;
        me.targetURL = '';

        var show = {};
        show.yandex  = me.prefs.getBoolPref('yandex');
        show.tineye  = me.prefs.getBoolPref('tineye');
        show.google  = me.prefs.getBoolPref('google');
        show.vk      = me.prefs.getBoolPref('vk') && me.getVKID(gContextMenu);

        var total = 0 + show.yandex + show.tineye + show.google + show.vk;

        var search = {};
        search.yandex = document.getElementById("context-imagedups-search-yandex");
        search.google = document.getElementById("context-imagedups-search-google");
        search.tineye = document.getElementById("context-imagedups-search-tineye");
        search.vk     = document.getElementById("context-imagedups-search-vk");
        search.all    = document.getElementById("context-imagedups-search-all");

        search.yandex.hidden = true;
        search.google.hidden = true;
        search.tineye.hidden = true;
        search.vk.hidden     = true;
        search.all.hidden    = true;

        var separator = document.getElementById("context-imagedups-separator");
        separator.hidden = true;

        if (gContextMenu.onImage)
    	{
            me.targetURL = gContextMenu.mediaURL || gContextMenu.imageURL;
            if (me.targetURL && !me.targetURL.match(/^(https?|data|file)\:/i))
            {
                me.targetURL = '';
            }
        }

        if (!me.targetURL && gContextMenu.hasBGImage && !gContextMenu.isTextSelected)
        {
            me.targetURL = gContextMenu.bgImageURL;
            if (me.targetURL && !me.targetURL.match(/^(https?|data|file)\:/i))
            {
                me.targetURL = '';
            }
        }

        if (me.targetURL)
        {
            if (show.yandex) search.yandex.hidden = false;
            if (show.tineye) search.tineye.hidden = false;
            if (show.google) search.google.hidden = false;
            if (show.vk)     search.vk.hidden     = false;

            search.all.hidden = (total < 2);
            separator.hidden  = (total < 1);
        }

        var upload = {};
        upload.yandex = document.getElementById("context-imagedups-upload-yandex");
        upload.google = document.getElementById("context-imagedups-upload-google");
        upload.tineye = document.getElementById("context-imagedups-upload-tineye");
        upload.all    = document.getElementById("context-imagedups-upload-all");

        show.yandex   = me.prefs.getBoolPref('yandex.upload');
        show.tineye   = me.prefs.getBoolPref('tineye.upload');
        show.google   = me.prefs.getBoolPref('google.upload');
        total         = 0 + show.yandex + show.tineye + show.google;

        upload.yandex.hidden = !show.yandex;
        upload.google.hidden = !show.google;
        upload.tineye.hidden = !show.tineye;
        upload.all.hidden    = (total < 2);
    },

    getVKID: function(contextMenu)
    {
        var me = whoStole.wink.images;
        me.vkID = '';

        if (contextMenu.onImage && contextMenu.target)
        {
            var target = contextMenu.target;
            var doc = target.ownerDocument || contextMenu.ownerDoc;

            if (!doc || doc.location.host !== 'vk.com') return '';

            var exp = /z\=([^%]+)/; exp = exp.exec(doc.location.search);
            if (exp)
            {
                me.vkID = exp[1];
            }
            if (!me.vkID && contextMenu.link)
            {
                exp = /vk.com[\/](photo[-0-9_]+)/; exp = exp.exec(contextMenu.link.href);
                if (exp)
                {
                    me.vkID = exp[1];
                }
            }
            if (!me.vkID && (target.tagName === 'IMG') && target.parentElement)
            {
                exp = /showPhoto\('([^']+)/; exp = exp.exec(target.parentElement.outerHTML);
                if (exp)
                {
                    me.vkID = 'photo' + exp[1];
                }
            }
        }
        return me.vkID;
    },

    Search: function(type)
    {
        var me = whoStole.wink.images;
        if (!me.targetURL) return;

        me.isLocalSearch = false;

        if (me.vkID && me.prefs.getBoolPref('vk'))
        {
            if (!type || type === 'vk')
            {
                openUILinkIn(me.searchURL['vk'] + encodeURIComponent(me.vkID), me.whereWeOpen());
                me.vkID = '';
            }
        }
        if (me.targetURL.match(/^data/i))
        {
            me.SearchDataURI(type, me.targetURL);
        }
        if (me.targetURL.match(/^file/i))
        {
            me.SearchFileURI(type, me.targetURL);
        }
        if (me.targetURL.match(/^http/i))
        {
            me.SearchImgURL(type, me.targetURL);
        }
        me.targetURL = '';
    },

    Upload: function(type)
    {
        var nsIFilePicker = Components.interfaces.nsIFilePicker;

        var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
            fp.init(window, null, nsIFilePicker.modeOpen);
            fp.appendFilters(nsIFilePicker.filterImages);

        var res = fp.show();
        if (res !== nsIFilePicker.returnOK) return;

        whoStole.wink.images.isLocalSearch = true;
        whoStole.wink.images.SearchFileURI(type, fp.fileURL.asciiSpec);
    },

    SearchDataURI: function(type, targetURL, leafName)
    {
        var me = whoStole.wink.images, s = targetURL.indexOf(',');
        if (s == -1) return;

        var prefix = targetURL.substring(0, s).toLowerCase();
        var base64Data = targetURL.substring(s + 1);

        if (prefix.indexOf(';base64') == -1)
        {
            base64Data = btoa(base64Data);
        }
        var mimeType = prefix.replace('data:', '').replace(';base64', '').trim() || "image/jpeg";

        var imgListener = function(event)
        {
            var et = event.target;
                et.removeEventListener('load', imgListener, false);

            var maxSize = Math.max(et.height, et.width);

            if (maxSize && (maxSize > me.tmbSize))
            {
                var idx = me.tmbSize / maxSize;
                var newHeight = Math.floor(idx * et.height);
                var newWidth  = Math.floor(idx * et.width);

                var canvas = document.createElementNS('http://www.w3.org/1999/xhtml', 'canvas');
                    canvas.width = newWidth;
                    canvas.height = newHeight;
                    canvas.getContext('2d').drawImage(et, 0, 0, newWidth, newHeight);

                base64Data = canvas.toDataURL(mimeType, 1.0).replace(/^.*base64,/, "");
            }
            whoStole.wink.images.selectUpload(type, leafName, mimeType, base64Data);
        };

        var img = new Image();
            img.addEventListener('load', imgListener, false);
            img.src = targetURL;
    },

    SearchFileURI: function(type, targetURL)
    {
        var io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        var path = io.newURI(targetURL, null, null).QueryInterface(Components.interfaces.nsIFileURL).file.path;

        var file   = new (window.File)(path);
        var reader = new (window.FileReader)();

        reader.onloadend = function()
        {
            whoStole.wink.images.SearchDataURI(type, reader.result, file.name);
        };
        reader.readAsDataURL(file);
    },

    SearchImgURL: function(type, targetURL)
    {
        var me = whoStole.wink.images, leafName = targetURL.split("/").pop() || 'image.jpg';

        var imgListener = function(event)
        {
            var et = event.target;
                et.removeEventListener('load', imgListener, false);
                et.removeEventListener('error', errListener, false);
            try
            {
                var maxSize = Math.max(et.height, et.width);

                var idx = me.tmbSize / maxSize;
                var newHeight = Math.min(et.height, Math.floor(idx * et.height));
                var newWidth  = Math.min(et.width,  Math.floor(idx * et.width));

                var io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
                var URI = io.newURI(targetURL, null, null);

                var mimeService = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
                var mimeType = "image/jpeg";
                try
                {
                    mimeType = mimeService.getTypeFromURI(URI);
                }
                catch(e) {}

                var canvas = document.createElementNS('http://www.w3.org/1999/xhtml', 'canvas');
                    canvas.width = newWidth;
                    canvas.height = newHeight;
                    canvas.getContext('2d').drawImage(et, 0, 0, newWidth, newHeight);

                var base64Data = canvas.toDataURL(mimeType, 1.0).replace(/^.*base64,/, "");

                me.selectUpload(type, leafName, mimeType, base64Data);
            }
            catch(e)
            {
                me.selectOpen(type, targetURL);
            }
        };

        var errListener = function(event)
        {
            var et = event.target;
                et.removeEventListener('load', imgListener, false);
                et.removeEventListener('error', errListener, false);

            me.selectOpen(type, targetURL);
        };

        var img = new Image();
            img.addEventListener('load', imgListener, false);
            img.addEventListener('error', errListener, false);
            img.src = targetURL;
    },

    UploadTo: function(type, leafName, mimeType, base64Data)
    {
        var me = whoStole.wink.images, sendURL = me.uploadURL[type];

        var nl = "\r\n", nl2 = "\r\n\r\n";
        var boundary = "-------------------------" + Math.ceil(Math.random() * 1000000000000);
        var dataString  = '--' + boundary + nl;

        if (type == 'tineye')
        {
            dataString += 'Content-Disposition: form-data; name="image"; filename="' + leafName + '"'+ nl + 'Content-Type: ' + mimeType + nl2 + atob(base64Data) + nl;
        }
        if (type == 'yandex')
        {
            dataString += 'Content-Disposition: form-data; name="upfile"; filename="' + leafName + '"'+ nl + 'Content-Type: ' + mimeType + nl2 + atob(base64Data) + nl;
            dataString += '--' + boundary + nl;
            dataString += 'Content-Disposition: form-data; name="rpt"' + nl2 + 'imageview' + nl;
        }
        if (type == 'google')
        {
            var inlineImage  = base64Data.replace(/\+/g, '-').replace(/[\/]{1}/g, '_').replace(/\./g, '=');

            dataString += 'Content-Disposition: form-data; name="image_content"' + nl2 + inlineImage + nl;
            dataString += '--' + boundary + nl;
            dataString += 'Content-Disposition: form-data; name="sbisrc"' + nl2 + "ff_1_0_0" + nl;
            dataString += '--' + boundary + nl;
            dataString += 'Content-Disposition: form-data; name="filename"' + nl2 + "" + nl;
            dataString += '--' + boundary + nl;
            dataString += 'Content-Disposition: form-data; name="image_url"' + nl2 + "" + nl;
        }
            dataString += '--' + boundary + '--' + nl;

        var stringStream = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(Components.interfaces.nsIStringInputStream);
            stringStream.setData(dataString, dataString.length);

        var postData = Components.classes["@mozilla.org/network/mime-input-stream;1"].createInstance(Components.interfaces.nsIMIMEInputStream);
            postData.addHeader("Content-Type", "multipart/form-data; boundary=" + boundary);
            postData.addContentLength = true;
            postData.setData(stringStream);

        if (me.prefs.getBoolPref('private'))
        {
            me.openInPrivateWindow(sendURL, postData);
        }
        else
        {
            openUILinkIn(sendURL, me.whereWeOpen(), false, postData, null);
        }
    },

    // Search by img URL if resize fail
    selectOpen: function(type, targetURL)
    {
        var me = whoStole.wink.images, open = function(stype)
        {
            if (me.prefs.getBoolPref('private'))
            {
                me.openInPrivateWindow(me.searchURL[stype] + encodeURIComponent(targetURL), null);
            }
            else
            {
                openUILinkIn(me.searchURL[stype] + encodeURIComponent(targetURL), me.whereWeOpen());
            }
        };
        if (!type)
        {
            if (me.prefs.getBoolPref('yandex')) open("yandex");
            if (me.prefs.getBoolPref('google')) open("google");
            if (me.prefs.getBoolPref('tineye')) open("tineye");
        }
        else open(type);
    },

    selectUpload: function(type, leafName, mimeType, base64Data)
    {
        var me = whoStole.wink.images;
        if (!type)
        {
            if (me.isLocalSearch)
            {
                if (me.prefs.getBoolPref('yandex.upload'))  me.UploadTo("yandex", leafName, mimeType, base64Data);
                if (me.prefs.getBoolPref('google.upload'))  me.UploadTo("google", leafName, mimeType, base64Data);
                if (me.prefs.getBoolPref('tineye.upload'))  me.UploadTo("tineye", leafName, mimeType, base64Data);
            }
            else
            {
                if (me.prefs.getBoolPref('yandex'))  me.UploadTo("yandex", leafName, mimeType, base64Data);
                if (me.prefs.getBoolPref('google'))  me.UploadTo("google", leafName, mimeType, base64Data);
                if (me.prefs.getBoolPref('tineye'))  me.UploadTo("tineye", leafName, mimeType, base64Data);
            }
        }
        else me.UploadTo(type, leafName, mimeType, base64Data);
    },

    openInPrivateWindow: function(sendURL, postData)
    {
        var where  = whoStole.wink.images.whereWeOpen();
        var params =
        {
            allowThirdPartyFixup: false,
            postData: postData,
            referrerURI: null,
            fromChrome: true,
            'private': true
        };

        if (PrivateBrowsingUtils.isWindowPrivate(content.document.defaultView))
        {
            openLinkIn(sendURL, where, params);
            return;
        }
        var em = Services.wm.getEnumerator("navigator:browser");
        while (em.hasMoreElements())
        {
            var win = em.getNext();
            if (PrivateBrowsingUtils.isWindowPrivate(win))
            {
                win.openLinkIn(sendURL, where, params);
                return;
            }
        }
        openLinkIn(sendURL, "window", params);
    }
};


window.addEventListener("load", whoStole.wink.images.init, false);
